CMSIS-DSP: Vector Negate

| CMSIS-DSP Version 1.4.7 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Vector Negate
Basic Math Functions

## Functions
void | arm_negate_f32 (float32_t *pSrc, float32_t *pDst, uint32_t blockSize)
| Negates the elements of a floating-point vector.
void | arm_negate_q15 (q15_t *pSrc, q15_t *pDst, uint32_t blockSize)
| Negates the elements of a Q15 vector.
void | arm_negate_q31 (q31_t *pSrc, q31_t *pDst, uint32_t blockSize)
| Negates the elements of a Q31 vector.
void | arm_negate_q7 (q7_t *pSrc, q7_t *pDst, uint32_t blockSize)
| Negates the elements of a Q7 vector.

## Description

Negates the elements of a vector.

        pDst[n] = -pSrc[n],   0 <= n < blockSize.

The functions support in-place computation allowing the source and destination pointers to reference the same memory buffer. There are separate functions for floating-point, Q7, Q15, and Q31 data types.

## Function Documentation

void arm_negate_f32 | ( | float32_t * | pSrc,
|  | float32_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *pSrc | points to the input vector
  [out] | *pDst | points to the output vector
  [in] | blockSize | number of samples in the vector

Returns
  none.

References blockSize.

void arm_negate_q15 | ( | q15_t * | pSrc,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *pSrc | points to the input vector
  [out] | *pDst | points to the output vector
  [in] | blockSize | number of samples in the vector

Returns
  none.

Conditions for optimum performance
  Input and output buffers should be aligned by 32-bit

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. The Q15 value -1 (0x8000) will be saturated to the maximum allowable positive value 0x7FFF.

References _SIMD32_OFFSET, and blockSize.

void arm_negate_q31 | ( | q31_t * | pSrc,
|  | q31_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *pSrc | points to the input vector
  [out] | *pDst | points to the output vector
  [in] | blockSize | number of samples in the vector

Returns
  none.

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. The Q31 value -1 (0x80000000) will be saturated to the maximum allowable positive value 0x7FFFFFFF.

References blockSize.

void arm_negate_q7 | ( | q7_t * | pSrc,
|  | q7_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *pSrc | points to the input vector
  [out] | *pDst | points to the output vector
  [in] | blockSize | number of samples in the vector

Returns
  none.

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. The Q7 value -1 (0x80) will be saturated to the maximum allowable positive value 0x7F.

References __SIMD32, and blockSize.